

#include <windows.h>
#include "..\hotpatch.h"

#define _s(s) (sizeof(s)/sizeof(*s))



DWORD WINAPI NewDivide(DWORD Dividend, DWORD Divisor) {
  return(Divisor ? Dividend / Divisor : 0);
}



const HOTPATCH_FIXUP_REGION FixupRgns[] = {
  {0, 0, {0, 0}}
};


const BYTE DivideBytes0[] = {0xCC, 0xCC, 0xCC, 0xCC, 0xCC};
const BYTE DivideBytes1[] = {0x8B, 0xFF};

HOTPATCH_VALIDATION Validations[] = {
  {0, 0x106B, 5, HOTP_Valid_Hook_Target},
  {0, 0x1070, 2, HOTP_Valid_Hook_Target}
};


HOTPATCH_HOOK Hooks[] = {
  {HOTP_Hook_X86_JMP,   5, 0x106B, +0, 0},
  {HOTP_Hook_X86_JMP2B, 2, 0x1070, -7, 0}
};


#pragma data_seg(".hotp1  ")
HOTPATCH_HEADER HotPatch = {
  HOTP_SIGNATURE,
  HOTP_VERSION_1,
  _s(FixupRgns),
  0,
  _s(Validations),
  0,
  _s(Hooks),
  0,
  0x33330000,
  0x22220000,
  0,
  HOTP_ID_None
};
#pragma data_seg()



#define TARGET_NAME "Divide.dll"

BOOLEAN WINAPI DllMain(HMODULE hDll, ULONG Reason, LPVOID lpReserved) {
  if(Reason == DLL_PROCESS_ATTACH) {
    ULONG_PTR SourceBase = (ULONGLONG)hDll;
    HotPatch.FixupRgnRva = (DWORD)((ULONG_PTR)FixupRgns -SourceBase);
    HotPatch.ValidationArrayRva = (DWORD)((ULONG_PTR)Validations -SourceBase);
    HotPatch.HookArrayRva = (DWORD)((ULONG_PTR)Hooks -SourceBase);
    HotPatch.TargetNameRva = (DWORD)((ULONG_PTR)TARGET_NAME -SourceBase);

    Validations[0].SourceRva = (DWORD)((ULONG_PTR)DivideBytes0 -SourceBase);
    Validations[1].SourceRva = (DWORD)((ULONG_PTR)DivideBytes1 -SourceBase);

    Hooks[0].HotpRva = (DWORD)((ULONG_PTR)NewDivide -SourceBase);
    Hooks[0].ValidationRva = (DWORD)((ULONG_PTR)&Validations[0] -SourceBase);
    Hooks[1].ValidationRva = (DWORD)((ULONG_PTR)&Validations[1] -SourceBase);
  }
  return(TRUE);
}
